# Architecture

## Files

- `main.c`  : Main programm, call the YACC/LEX parse on the input.

- `corec.l` : Lex file.
- `corecDev.l` : Lex file with print.
- `corec.y` : YACC file.

- `lib.c` : Management of the code struct (intermediate code) and the table of symbols.

## Intermediate code generation (3 addresses)

The yacc file call the function `gencode` (define in [lib.c](./../lib.c)) when he's parsing. The `gencode` function generate intermediate code stored in a structure named `code`. The data of the struct can be displayed in commentary inside the output file with the `code_dump` function (define in [lib.c](./../lib.c)).

The `struct code` has 3 attributs because we need to generate 3 addresses intermediate code. This need is due to the assembly language which works with 3 memory addresses at the time. 

## Code generation

The generation of the assembly code is similar to the `code_dump` function. For that, the `code_mips_dump` function (define in [lib.c](./../lib.c)) iterate on the data of the `struct code`, and translate the intermediate code in mips code, instruction per instruction.

## Navigation
Return to the main documentation -> [click here](./../README.md).